// Listeners working from v1.9 and later versions.
$(document).on("click", "#eventlistview li", function() {
    localStorage.setItem('clicked_event', $(this).data("eventid"));
    console.log("Clicked unattending event: "+localStorage.getItem("clicked_event"));
    getAttendingUsers(parseInt(localStorage.clicked_event,0));
    getEventListview(); // Event information listview
});

$(document).on("click", "#pastEventsListview li", function() {
    localStorage.setItem('clicked_past_event', $(this).data("eventid"));
    console.log("Clicked past event: "+localStorage.getItem("clicked_past_event"));
    getAttendingUsers(parseInt(localStorage.clicked_past_event,0));
    //getPastEventInformationListview(); // ADDED 16:38
});

$(document).on("click", "#registeredEventsListview li", function() {
    localStorage.setItem('clicked_attending_event', $(this).data("eventid"));
    console.log("Clicked attending event: "+localStorage.getItem("clicked_attending_event"));
    getAttendingUsers(parseInt(localStorage.clicked_attending_event,0));
    getAttendingEventListview();
});

$(document).on("click", "#friendslistview li", function() {
    localStorage.setItem('clicked_friend_event', $(this).data("eventid"));
    console.log("Clicked friend event: "+localStorage.getItem("clicked_friend_event"));
    getAttendingUsers(parseInt(localStorage.clicked_friend_event,0));
    getFriendEventInfo();
});

$(document).on("click", "#attend", function() {
	//initActivities();
	var eventid = parseInt(localStorage.clicked_event);
    console.log(localStorage.clicked_event);
	signup(eventid);
});

$(document).on("click", "#attendInvite", function() {
    //initActivities();
    responseToInvitation(1, "Jeg blir med!", localStorage.clicked_event_invitation);
    var eventid = parseInt(localStorage.clicked_event_invitation);
    console.log(localStorage.clicked_event_invitation);
    signupInvite(eventid);
});

$(document).on("click", "#attendfriend", function() {
    //initActivities();
    var eventid = parseInt(localStorage.clicked_friend_event);
    signup(eventid);
});

$(document).on("click", "#cancel_signup", function() {
	var eventid = parseInt(localStorage.clicked_attending_event);
	cancelRegistration(eventid);
	//initActivities();
});

$(document).on("click", "#invite_button", function() {
    var eventid = parseInt(localStorage.clicked_attending_event);
    console.log("eventid: "+eventid);
    $.mobile.changePage("#send_invitation");
    //cancelRegistration(eventid);
    //initActivities();
});

$(document).on("click", ".navbarbutton", function() {
    $.each($('.navbarbutton'), function(){
        $(this).removeClass("ui-btn-active ui-state-persist");
    });
    $(this).addClass("ui-btn-active ui-state-persist");
    $.mobile.silentScroll(0);
});

$(document).on("click", "#friendrequestlistview li", function(){
    localStorage.setItem('clicked_friend_first', $(this).data("firstname"));
    console.log($(this).data("firstname") + $(this).data("lastname") + $(this).data("id"));
    localStorage.setItem('clicked_friend_last', $(this).data("lastname"));
    //console.log($(this).data("eventID"));
    localStorage.setItem('clicked_friend_eventID', $(this).data("id"));
    localStorage.guestid = $(this).data("guestid");
    console.log("Clicked friend: "+localStorage.getItem("clicked_friend_first") + " "+localStorage.getItem("clicked_friend_last") + " "+ localStorage.getItem("clicked_friend_eventID"));
    getFriendInviteView();
});

$(document).on("click", "#invitationlistview li", function(){
    localStorage.clicked_event_invitation = $(this).data("eventid");
    if (localStorage.clicked_event_invitation != "undefined") {
        getAttendingUsers(parseInt(localStorage.clicked_event_invitation, 10));
        getEventInvitationListview();
        getNormalEventInvitationListview();
        getCinemaEventListview();
    }; 
});

$(document).on("click", "#waffle_signup_positive", function(){
     responseToInvitation(1, "Jeg blir med!", localStorage.clicked_event_invitation);
    var eventid = parseInt(localStorage.clicked_event_invitation);
    console.log(localStorage.clicked_event_invitation);
    signupInvite(eventid);
});

$(document).on("click", "#waffle_signup_negative", function(){
    responseToInvitation(2, "Jeg staar over!", $.parseJSON(localStorage.currentEvent).eventID);
    //localStorage.clicked_event_invitation = $(this).data("eventid"); 
});

$(document).on("click", "#friend_positive", function(){
    console.log("KRM" +localStorage.clicked_friend_event);
    responseToInvitation(1, "Ja jeg vil bli venn!", localStorage.clicked_friend_eventID);
    acceptFriendRequest();

   
    getFriendsActivities();
    getFriendEventsListview();
    //localStorage.clicked_event_invitation = $(this).data("eventid"); 
});

$(document).on("click", "#friend_negative", function(){
    responseToInvitation(2, "Nei takk", localStorage.clicked_friend_eventID);
    //localStorage.clicked_event_invitation = $(this).data("eventid"); 
});

$(document).on("click", "#meetups_listview li", function() {
    localStorage.clicked_meetup_event = $(this).data("eventid");

    var eventID = localStorage.clicked_meetup_event;
    getEventInformation(eventID);
    //getAttendingUsers(eventID);
    //getQuiz();
    // getQuizPageListview();
    // refreshQuizListview();
});

$(document).on("click", "#quizanswer", function(){
    answerQuestion(refreshQuizListview);
});

$(document).on("click", "#waffletoggle", function(){
    refreshQuizListview();
});

$(document).on("click", "#coupons_listview li", function(){
    localStorage.clicked_coupon_type = $(this).data("coupontype");
    getActiveCouponListview();
    console.log($(this).data("coupontype"));
});

$(document).on("click", "#usecoupon", function(){
    $.mobile.changePage("#confirmdialog");
});

$(document).on("click", "#removecoupon", function(){
    removeCoupon(localStorage.clicked_coupon_type);
    window.history.go(-2);
});

$(document).on("click", "#main-menu-img2", function(){

});

$(document).on("click", "#attend_cinema", function(){
    if(localStorage.clicked_event_invitation != undefined){
        signup(localStorage.clicked_event_invitation);
        responseToInvitation(1, "Nei takk", localStorage.clicked_event_invitation);
    }    
});



