/*global $:false */
function login(){
    'use strict';
    $.soap({
    url: 'http://coliving-prod.sintef9013.com:8080/security-web-0.2-SNAPSHOT/AuthenticationWServiceService?wsdl',
    // PROD SERVER
    //url: 'http://coliving-prod.sintef9013.com:8080/security-web-0.2-SNAPSHOT/AuthenticationWServiceService?wsdl',
    method: 'authenticateUserPass',
    namespaceUrl: 'http://soap.types.security.framework.mpower.eu',
    namespaceQualifier: 'tns',
    appendMethodToURL: false,
    params: {
        username: $('#usr').val(),
        password: $('#pwd').val()
    },
         
    success: function (soapResponse) {

        if ($(soapResponse.content).find('message').text() === 'Login succeeded!') {
            var userID = $(soapResponse.content).find('userID').text();
            var sessionId = $(soapResponse.content).find('sessionId').text();
            var primaryRoleName = $(soapResponse.content).find('primaryRoleName').text();
            var roleNames = $(soapResponse.content).find('roleNames').text();
            var authenticationTime = $(soapResponse.content).find('authenticationTime').text();
            var serviceID = $(soapResponse.content).find('serviceIDs').text();

           
            localStorage.clear();
            var testObject = {'userID': userID, 'sessionID': sessionId, 'primaryRoleName': primaryRoleName, 'roleNames': roleNames, 'authenticationTime': authenticationTime, 'serviceID': serviceID};
            localStorage.setItem('testObject', JSON.stringify(testObject));
            var retrievedObject = localStorage.getItem('testObject');
            console.log('retrievedObject: ', JSON.parse(retrievedObject));
            // console.log($.token.userID + " " + $.token.sessionID + " " + $.token.primaryRoleName + " " + $.token.roleNames 
            //     + " " + $.token.authenticationTime + " " + $.token.serviceID);
            var deviceType = (navigator.userAgent.match(/iPad/i))  == "iPad" ? "iPad" : (navigator.userAgent.match(/iPhone/i))  == "iPhone" ? "iPhone" : (navigator.userAgent.match(/Android/i)) == "Android" ? "Android" : (navigator.userAgent.match(/BlackBerry/i)) == "BlackBerry" ? "BlackBerry" : "null";
            
            localStorage.setItem('device', JSON.stringify(deviceType));
            
            getPersonId();
        }else{
            alert('Feil brukernavn eller passord');
        }      

    },
    error: function (SOAPResponse) {
       alert('Server might be down!'+SOAPResponse);
    }
    });
}

function checkLogin(){
    if (localStorage.getItem("testObject") !== null) {
        getPersonId();
    }
}

function getPersonId(){
    'use strict';
     $.soap({
    url: 'http://coliving-prod.sintef9013.com:8080/security-web-0.2-SNAPSHOT/UserManagementService?xsd=2',
    // PROD SERVER
    //url: 'http://coliving-prod.sintef9013.com:8080/security-web-0.2-SNAPSHOT/UserManagementService?xsd=2',
    method: 'getPersonIDByUserName',
    namespaceUrl: 'http://accesscontrol.security.mpower.eu/',
    namespaceQualifier: 'tns',
    appendMethodToURL: false,
    params: {
        username: $('#usr').val()
    },
    success: function (soapResponse) {
        console.log("success: "+soapResponse);
        var personIdXML=soapResponse.toXML();
        var personID = personIdXML.getElementsByTagName("return")[0].firstChild.nodeValue;
        localStorage.setItem('personID', personID);
        initActivities();
        
    },
    error: function (SOAPResponse) {
        console.log("ERROR: "+SOAPResponse);
    }
    });
}

