//------------------------------------------START COUPON DB HANDLING----------------------------------------------------//

function getCoupons(){
    var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
    db.transaction(queryDB, errorCB);
}

function addCoupon(type){
    var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
    if(type == "coffee") db.transaction(queryAddCoffeeCoupon, errorCB);
    else db.transaction(queryAddWaffleCoupon, errorCB);
    //alert("ADD COUPON!");
    getCoupons();
}

function queryAddCoffeeCoupon(tx){
    date = new Date(2013, 4, 29, 0, 0, 0, 0).getTime();
    tx.executeSql('INSERT INTO COUPONS (data, date) VALUES ("coffee", "'+date+'")');
}

function queryAddWaffleCoupon(tx){
    date = new Date(2013, 4, 29, 0, 0, 0, 0).getTime();
    tx.executeSql('INSERT INTO COUPONS (data, date) VALUES ("waffle", "'+date+'")');
}

function deleteAllCoupons(){
    var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
    db.transaction(queryDeleteAllCoupons, errorCB);
    getCoupons();
}

function initDB(){
    var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
    db.transaction(createDB, errorCB);   
}

function queryDeleteAllCoupons(tx){
    tx.executeSql('DELETE FROM COUPONS');
}

function upgradeCoupon(){
    upgraded = false;
    if(localStorage.coupons != undefined){
        $.each($.parseJSON(localStorage.coupons), function(){
            if(this.type == "waffle" && !upgraded){
                removeCoupon("waffle");
                addCoupon("coffee");
                upgraded = true;
            }
        });
    }
    //alert("UPGRADE COUPON!");
    getCoupons();
}

// function removeCoupon(type){
//     var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
//     if(type == "coffee") db.transaction(queryRemoveCoffeeCoupon, errorCB);
//     else db.transaction(queryRemoveWaffleCoupon, errorCB);
// }

function removeCoupon(type){
    var coupons = [];
    var waffle = 0;
    var coffee = 0;
    if(localStorage.coupons != undefined){
        $.each($.parseJSON(localStorage.coupons), function(){
            //if(this.toString() == "waffle") waffle++;
            if(this.type == "waffle") waffle++;
            else coffee++;
        });
    }

    if(type=="coffee"){
        coffee--;
        //console.log("coffee--");   
    } else {
        waffle--;
        //console.log("waffle--");
    }

    for(var i=0; i<coffee; i++){
        coupons.push("coffee");
    }
    for(var i=0; i<waffle; i++){
        coupons.push("waffle");
        //addCoupon("waffle");
    }
    //console.log(coupons);
    localStorage.coupons = JSON.stringify(coupons);
    //console.log(localStorage.coupons);
    refreshDB();
}

// Refreshes DB to mach localStorage
function refreshDB(){
    deleteAllCoupons();
    var waffle = 0;
    var coffee = 0;
    if(localStorage.coupons != undefined){
        $.each($.parseJSON(localStorage.coupons), function(){
            if(this.toString() == "waffle") waffle++;
            else coffee++;
        });
    }
    //console.log("coffee: "+coffee+" waffle: "+waffle);

    for(var i=0; i<coffee; i++){
        addCoupon("coffee");
    }
    for(var i=0; i<waffle; i++){
        addCoupon("waffle");
    }
    getCoupons();
    
}

// function queryRemoveCoffeeCoupon(tx){
//     tx.executeSql('DELETE TOP(1) FROM COUPONS WHERE DATA="coffee"');
// }

// function queryRemoveWaffleCoupon(tx){
//     //tx.executeSql('INSERT INTO COUPONS (data) VALUES ("waffle")');
// }

function createDB(tx) {
     //x.executeSql('DROP TABLE IF EXISTS COUPONS');
     // tx.executeSql('CREATE TABLE IF NOT EXISTS COUPONS (id unique, data)');
     // tx.executeSql('INSERT INTO COUPONS (id, data) VALUES (1, "coffee")');
     // tx.executeSql('INSERT INTO COUPONS (id, data) VALUES (2, "waffles")');
     tx.executeSql('CREATE TABLE IF NOT EXISTS COUPONS (data, date)');
}

function errorCB(err) {
    alert("Error processing SQL: "+err.code);
}

function successCB() {
    alert("success!");
}

function queryDB(tx) {
    tx.executeSql('SELECT * FROM COUPONS', [], querySuccess, errorCB);
}

function querySuccess(tx, results) {
    var len = results.rows.length;   
    var coupons = [];
    for (var i=0; i<len; i++){
        //console.log("Row = " + i + " ID = " + results.rows.item(i).id + " Data =  " + results.rows.item(i).data);
        var c = new Object();
        c.type = results.rows.item(i).data;
        c.date = results.rows.item(i).date;
        coupons.push(c);
    }
    localStorage.coupons = JSON.stringify(coupons);
    //console.log(localStorage.coupons);
    getCouponsListview();
}

function errorCB(err) {
    alert("Error processing SQL: "+err.code);
}

//------------------------------------------END COUPON DB HANDLING------------------------------------------------------//

function getQuizState(){
    // DB holding personID of answered questions
    // Get them, and modify localstorage to mirror quiz state.
    
    var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
    db.transaction(createAnswersTable, errorCB);
    db.transaction(queryGetAnswers, errorCB);
}

// Callback for successfully adding answer (queryAddAnswer)
function addAnswerSuccess(){
    checkReward();
    // getSynchronizedQuizState();
    // refreshQuizListview();
    // // getMeetupsListview();
    // console.log("addAnswerSuccess");
}

function addAnswerToDB(){
    var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
    db.transaction(createAnswersTable, errorCB);
    db.transaction(queryAddAnswer, errorCB);
    // tx.executeSql('SELECT * FROM COUPONS', [], querySuccess, errorCB);
}

function createAnswersTable(tx) {
     //x.executeSql('DROP TABLE IF EXISTS COUPONS');
     // tx.executeSql('CREATE TABLE IF NOT EXISTS COUPONS (id unique, data)');
     // tx.executeSql('INSERT INTO COUPONS (id, data) VALUES (1, "coffee")');
     // tx.executeSql('INSERT INTO COUPONS (id, data) VALUES (2, "waffles")');
     tx.executeSql('CREATE TABLE IF NOT EXISTS ANSWERS (data)');
}

function queryAddAnswer(tx){
    tx.executeSql('INSERT INTO ANSWERS (data) VALUES ("'+localStorage.answerID+'")', [], addAnswerSuccess, errorCB);  
}

function deleteAnswers(){
    var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
    db.transaction(queryDeleteAllAnswers, errorCB);
    //getQuizState();
    getSynchronizedQuizState();
    refreshQuizListview();
}

function queryDeleteAllAnswers(tx){
    tx.executeSql('DELETE FROM ANSWERS');
}

function queryGetAnswers(tx) {
    tx.executeSql('SELECT * FROM ANSWERS', [], queryGetAnswersSuccess, errorCB);
}

function checkNumberOfAnswers(){
    var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
    db.transaction(queryGetNumberOfAnswers, errorCB);    
}

function queryGetNumberOfAnswers(tx){
    tx.executeSql('SELECT * FROM ANSWERS', [], queryGetNumberOfAnswersSuccess, errorCB);
}

function queryGetNumberOfAnswersSuccess(tx, results){
    var len = results.rows.length;
    localStorage.numberofanswers = len;
    // getMeetupsListview();
    // getQuizPageListview();
    // HANDLE SETTING OF QUIZ IMAGE AND COUPON IMAGE BASED ON THE NUMBER OF ANSWERS    
}

function checkReward(){
    var db = window.openDatabase("Database", "1.0", "Cordova DB", 200000);
    db.transaction(queryCheckReward, errorCB);
}

function queryCheckReward(tx) {
    tx.executeSql('SELECT * FROM ANSWERS', [], queryCheckRewardSuccess, errorCB);
}

function queryCheckRewardSuccess(tx, results) {
    var len = results.rows.length;   
    if(len == 1) { 
        addCoupon();
        $().toastmessage({sticky : false});
        $().toastmessage('showNoticeToast', "Du har nå fått en vaffelkupong. Den er tilgjengelig fra oversiktssiden.");
    }
    if(len == 4) {
        upgradeCoupon();
        $().toastmessage({sticky : false});
        $().toastmessage('showNoticeToast', "Du har nå fått en kaffe- og vaffelkupong. Den er tilgjengelig fra oversiktssiden.");
    }
}

function queryGetAnswersSuccess(tx, results) {
    var len = results.rows.length;   
    var answers = [];
    for (var i=0; i<len; i++){
        //console.log("Row = " + i + " ID = " + results.rows.item(i).id + " Data =  " + results.rows.item(i).data);
        //var a = new Object();
        answers.push(results.rows.item(i).data);
        //a.type = results.rows.item(i).data;
        //answers.push(a);
    }
    localStorage.db_answers = JSON.stringify(answers);
    //console.log(localStorage.db_answers);
    // checkCouponReward();
}

function updateLocalStorageAnswers(){
    getQuizState();
    if(localStorage.quiz != undefined){
        var quiz = $.parseJSON(localStorage.quiz);
        // console.log("Quiz before answers matching:");
        // console.log(quiz);
        if(localStorage.db_answers != undefined){
            var answers = $.parseJSON(localStorage.db_answers);
            $.each(answers, function(){
                pID = this.toString();
                $.each(quiz, function(){
                    //console.log(this.personID+" compared to "+pID);
                    if(this.personID == pID) this.answered = "true";
                });
            });      
        }
        localStorage.quiz = JSON.stringify(quiz);
        // console.log("Quiz after answers matching:");
        // console.log(quiz);
    }
}

function getSynchronizedQuizState(callback){
    //console.log("getSynchronizedQuizState"); 
    getQuiz();
    getQuizState();
    updateLocalStorageAnswers();
    if(callback) callback();
}

//------------------------------------------END QUIZ STATE DB HANDLING------------------------------------------------------//

function getActiveCouponListview(){
    $('#couponcontent').append("<div data-role='listview' id=activecouponlistview data-inset='true'></div>");

    $('#activecouponlistview').empty();

    var imgURL = "";
    var text = "";
    var text2 = " og kan innløses ved Hornemannsgården."

    if(localStorage.clicked_coupon_type == "coffee"){
        imgURL = "<img src='images/coffeewaffle.png' class='activecoupon'/>";
        text = "Denne kupongen gir en gratis vaffel og en kopp kaffe. ";
    }else if(localStorage.clicked_coupon_type == "waffle"){
        imgURL = "<img src='images/waffle.png' class='activecoupon'/>";
        text = "Denne kupongen gir en gratis vaffel. ";
    } 

    $('#activecouponlistview').append("<li style='height: 150px;'>"+imgURL+"</li>");

    $('#activecouponlistview').append("<li>"+text+"</li>");

    $('#activecouponlistview').append("<li> Tid: Innen Onsdag 29.05.2013 <br><br> Sted: Hornemannsgården </li>");

    $('#activecouponlistview').append("<li><button id='usecoupon' data-mini='true'>Innløs kupong</button><li>");

    if($("#activecouponlistview").hasClass('ui-listview')) $("#activecouponlistview").listview("refresh");
    $('#usecoupon').button();
}

function getQuestion(){

    debug = false;

    var output = "Ingen spørsmål innhentet <br><br><p style='white-space: normal'> Trykk på vaffelen for å få et spørsmål.</p>";

    var post_question_text = "<br><br><p style='white-space: normal'> Hvis du ikke vet svaret, kan du trykke på vaffelen for å få et nytt spørsmål.</p>";

    var attending = [];
    if(localStorage.quiz != undefined){
        $.each($.parseJSON(localStorage.quiz), function(){
            if(this.answered == "false"){
                attending.push(this);         
            }
        });
    }
    // hvis det bare er én kis i lista, så må denne personens spørsmål returneres.
    if(attending.length == 1) {
        localStorage.currentQuizPerson = JSON.stringify(attending[0]);
        return attending[0].question+post_question_text;
    }

    // Filter out last person from new selection
    var questions = [];
    //console.log("----------------");
    $.each(attending, function(){
        if(localStorage.currentQuizPerson == undefined){
            questions.push(this);
        } else {
            var p = $.parseJSON(localStorage.currentQuizPerson);
            //console.log(this.personID+" compared to "+p.personID);
            if (this.personID != p.personID){
                //console.log("Not matched.");
                questions.push(this);
            } else {
                //console.log("Matched");
            }
        }
    });

    if(debug) console.log("-----------------------");
    if(debug) console.log("questions length: "+questions.length);
    if(questions.length > 1){
        var random = Math.floor(Math.random()*(questions.length));
        if(debug) console.log("Random index: "+random);

        var quizperson = questions[random];  
        if(quizperson != undefined){
            if(debug) console.log("quizperson.question: "+quizperson.question);
            localStorage.currentQuizPerson = JSON.stringify(quizperson);
            return quizperson.question+post_question_text;
        } else {
            if(debug) console.log("quizperson undefined!");
        }
    } else {
        if(debug) console.log("ELSE!");
        var quizperson = questions[0];
        if(quizperson != undefined){
            localStorage.currentQuizPerson = JSON.stringify(quizperson);
            return quizperson.question+post_question_text;
        }
    }
    // console.log("getQuestion quiz state:");
    // console.log(localStorage.quiz);
    return output;
}

function testRandomFunctionality(){
    debug = false;
    var zero = 0;
    var one = 0;
    var two = 0;
    var three = 0;

    for(var i=0; i<1000; i++){
        var lol = Math.floor(Math.random()*($.parseJSON(localStorage.quiz).length));
        switch(lol){
            case 0: zero++; break;
            case 1: one++; break;
            case 2: two++; break;
            case 3: three++; break;
        }
    }

    if(debug) console.log("0: "+zero);
    if(debug) console.log("1: "+one);
    if(debug) console.log("2: "+two);
    if(debug) console.log("3: "+three);   
}

function answercallback(){
    // alert("answercallback");
    // console.log("answer callback");
    // // getSynchronizedQuizState();
    // refreshQuizListview();
}

function answerQuestion(callback){
    var quizzer = $.parseJSON(localStorage.currentQuizPerson);
    // string1.toUpperCase() === string2.toUpperCase();
    if($('#answer').val().toUpperCase() == quizzer.answer.toUpperCase()){
        //alert("KORREKT! BRA!");
        // TODO Replace with toast with timeout.

        // MODIFISER LOCALSTORAGE.QUIZ!
        var answered = 0;
        var quiz = [];
        if(localStorage.quiz != undefined){
            quiz = $.parseJSON(localStorage.quiz);
            $.each(quiz, function(){
                if(this.personID == quizzer.personID){ 
                    this.answered = "true";
                    answered++;
                }
            });
        }

        localStorage.quiz = JSON.stringify(quiz);
        
        localStorage.answerID = quizzer.personID;

        addAnswerToDB();

        getMeetupsListview();

    } else {
        //alert("Feil svar. Prøv igjen.");
        // TODO Replace with toast with timeout.
    }
    if(callback) callback();
}

// UNUSED!
function checkCouponReward(){
    var answered = 0;
    getQuizState();
    if(localStorage.db_answers != undefined){
        answered = $.parseJSON(localStorage.db_answers).length;
    } else {
        //getQuizState();
        answered = $.parseJSON(localStorage.db_answers).length;
    }
}

// Quiz page listview!
function getQuizPageListview(){
    getSynchronizedQuizState();
    var start = "<li><b>";
    var mid = "<p class='ui-li-aside'>";
    var end = "</p></b></li>";

    $('#quizcontent').append($("<ul data-role='listview' id='quizlist' data-inset='true' data-theme='d' class='ui-icon-alt'>"));

    $('#quizlist').empty();

    var tekst = "Trykk på  vaffelen for å få opp spørsmål om de andre deltakerene!";
    var tekst2 = "Hvis du ikke vet svaret, kan du trykke på vaffelen for å få et nytt spørsmål.";

    $('#quizlist').append("<li>"+tekst+"</li>");

    if(localStorage.quiz != undefined){
        quiz = $.parseJSON(localStorage.quiz);
        var count = 0;
        $.each(quiz, function(){
            if(this.answered == "true") count++;
        })
        var attending = 4;
        if(localStorage.quiz_attendees != undefined){
            attending = $.parseJSON(localStorage.quiz_attendees).length-1;
        }
        $('#quizlist').append("<li> Du har svart på "+count+" av "+attending+" spørsmål.")
    }




    $('#quizlist').append("<li style='height: 160px;'>"+getQuizImage()+"</li>");
    //$('#quizlist').append("<li>"+getQuestion()+"<br><br><p style='white-space: normal'>"+tekst2+"</p></li>");
    $('#quizlist').append("<li>"+getQuestion()+"</li>");
    $('#quizlist').append("<li><div data-role='fieldcontain'><input type='text' name='answer' id='answer' value='' /></li>");
    $('#quizlist').append("<li><button id='quizanswer' data-mini='true'>Angi svar</button><li>");
    
    var css = "text-align: center;";

    var buttoncss = "width: 80px; position: relative; top: 10px;";

    if($("#quizlist").hasClass('ui-listview')) $("#quizlist").listview("refresh");

}

function refreshMeetupsListview(){
    getMeetupsListview();
    if($("#meetups_listview").hasClass('ui-listview')) $("#meetups_listview").listview("refresh");
}

function refreshQuizListview(){
    //console.log("refreshing quiz list");
    getQuizPageListview();
    $('#quizanswer').button();
    $('#answer').textinput();
    if($("#quizlist").hasClass('ui-listview')) $("#quizlist").listview("refresh");
}

function getMeetupsListview(){
    getSynchronizedQuizState();
    $('#meetups_listview').empty();
    $('#meetups_listview').append("<li data-role='list-divider'><b> Planlagte treff </b></li>");

    var date = "Onsdag 22.05.2013";

    // eventID for hvert listitem

    if(localStorage.meetups != undefined){
        $.each($.parseJSON(localStorage.meetups), function(){
            // append meetup to meetups_listview
            $('#meetups_listview').append("<li data-eventID="+this.eventID+"><a href='#meetupGame'>"+getQuizIcon()+"<b style='white-space: normal'>"+this.name+"</b><br><b style='white-space: normal'>"+this.description+"</b><br><br>"+date+"<br> Klokken 12:00"+"</a></li>");
        });
    } else {
        $('#meetups_listview').append("<li> Ingen.</li>");
    }

    // IF MEETUPS IS DEFINED, BUT NO EVENTS ARE ADDED. STILL HAS 1 ITEM, THE DIVIDER.
    if($('#meetups_listview li').size() == 1) $('#meetups_listview').append("<li> Ingen.</li>");

    if($("#meetups_listview").hasClass('ui-listview')) $("#meetups_listview").listview("refresh");

}

function getCouponsListview(){
    //getCoupons();
    $('#coupons_listview').empty();
    $('#coupons_listview').append("<li data-role='list-divider'><b> Kuponger </b></li>");

    if(localStorage.coupons != undefined){
        if($.parseJSON(localStorage.coupons).length > 0){
            $.each($.parseJSON(localStorage.coupons), function(){
                // append meetup to meetups_listview
                $('#coupons_listview').append("<li data-coupontype="+this.type+"><a href='#coupon'>"+getCouponImage(this)+"Må brukes innen: <br>"+formatDate(new Date(parseInt(this.date, 10)))+"</a></li>");
            });   
        } else {
            $('#coupons_listview').append("<li> Ingen.</li>");
        }
        
    } else {
        $('#coupons_listview').append("<li> Ingen.</li>");
    }
    if($("#coupons_listview").hasClass('ui-listview')) $("#coupons_listview").listview("refresh");
}

function getCouponImage(coupon){
    if(coupon.type == "coffee") return "<img src='images/coffeewaffle.png' class='couponitem'/>";
    else return "<img src='images/waffle.png' class='couponitem'/>";
}

function getQuizImage(){
    //checkNumberOfAnswers();
    var imgcss = "position: relative; top: 0; bottom: 0; left: 0; right: 0; margin:auto; width: 200px;";
    var answered = 0;
    //if(localStorage.numberofanswers != undefined) answered = parseInt(localStorage.numberofanswers,10);
    
    updateLocalStorageAnswers();
    if(localStorage.quiz != undefined){
        $.each($.parseJSON(localStorage.quiz), function(){
            if(this.answered != "false") answered++;
        });
    }
    switch(answered){
        case 0: return "<img src='images/waffles/1.png' id='waffletoggle'/>"; break;
        case 1: return "<img src='images/waffles/2.png' id='waffletoggle'/>"; break;
        case 2: return "<img src='images/waffles/3.png' id='waffletoggle'/>"; break;
        case 3: return "<img src='images/waffles/4.png' id='waffletoggle'/>"; break;
        case 4: return "<img src='images/waffles/5.png' id='waffletoggle'/>"; break;
    }
}

// Intended to get the correct waffle image depending on the quiz state (3 answers => 3 hearts etc.)
function getQuizIcon(){
    // checkNumberOfAnswers();
    var answered = 0;
    // if(localStorage.numberofanswers != undefined) answered = parseInt(localStorage.numberofanswers,10);



    if(localStorage.quiz != undefined){
        $.each($.parseJSON(localStorage.quiz), function(){
            if(this.answered != "false") answered++;
        });
    }
    switch(answered){
        case 0: return "<img src='images/waffles/1.png' class='couponitem'/>"; break;
        case 1: return "<img src='images/waffles/2.png' class='couponitem'/>"; break;
        case 2: return "<img src='images/waffles/3.png' class='couponitem'/>"; break;
        case 3: return "<img src='images/waffles/4.png' class='couponitem'/>"; break;
        case 4: return "<img src='images/waffles/5.png' class='couponitem'/>"; break;
    }
}

// Changed to take in no parameters. Depends on localStorage.attendees 
// being correctly set upon navigation to the event.
function getQuiz(){
    getQuizState();
    var users = [];

    $.getJSON('users.json', function(data){
        users = data.users;
        
        var quiz_participants = [];

        if(localStorage.quiz_attendees != undefined){
            $.each($.parseJSON(localStorage.quiz_attendees), function(){
                pid = this.personID;
                $.each(users, function(){
                    if(this.personID != localStorage.personID){
                        if(this.personID == pid) quiz_participants.push(this);
                    }
                });
            });
        }

        var filtered = setAnsweredQuestions(quiz_participants);

        var quiz_json = JSON.stringify(filtered);
        localStorage.quiz = quiz_json;

        // updateLocalStorageAnswers();

        // console.log("Quiz participants (getQuiz):");
        // console.log($.parseJSON(localStorage.quiz));
    });
}

function setAnsweredQuestions(list){
    if(localStorage.db_answers != undefined){
        answers = $.parseJSON(localStorage.db_answers);
        $.each(answers, function(){
            pID = this;
            $.each(list, function(){
                if(this.personID == pID) this.answered = "true";
            });
        });
    }
    return list;
}

function logCouponsExpirydate(){
    if(localStorage.coupons != undefined){
        $.each($.parseJSON(localStorage.coupons), function(){
            console.log(new Date(this.expirydate));
        });       
    }  
}

// Parameter defines wether or not the coupon is for one waffle, or for a waffle and a cup of coffee.
function createRewardCoupon(param){
    var c = new Object();

    if(param == "coffee"){
        c.type = "coffee";
    } else {
        c.type = "waffle";
    }
    
    c.expirydate = (new Date().getTime() + 1209600000); // + TWO WEEKS
    var coupons = [];
    if(localStorage.coupons != undefined){
        coupons = $.parseJSON(localStorage.coupons);
        coupons.push(c);
        localStorage.coupons = JSON.stringify(coupons);
    } else {
        coupons.push(c);
        localStorage.coupons = JSON.stringify(coupons);
    }
    logCouponsExpirydate();
    getCouponsListview();  
}

function formatDate(date){
    return date.customFormat("#DDDD# #DD#.#MM#.#YYYY#");
}

// CAN BE MOVED TO ANOTHER *.JS FILE
Date.prototype.customFormat = function(formatString){
    var YYYY,YY,MMMM,MMM,MM,M,DDDD,DDD,DD,D,hhh,hh,h,mm,m,ss,s,ampm,AMPM,dMod,th;
    var dateObject = this;
    YY = ((YYYY=dateObject.getFullYear())+"").slice(-2);
    MM = (M=dateObject.getMonth()+1)<10?('0'+M):M;
    MMM = (MMMM=["Januar","Februar","Mars","April","Mai","Juni","Juli","August","September","Oktober","November","Desember"][M-1]).substring(0,3);
    DD = (D=dateObject.getDate())<10?('0'+D):D;
    DDD = (DDDD=["Søndag","Mandag","Tirsdag","Onsdag","Torsdag","Fredag","Lørdag"][dateObject.getDay()]).substring(0,3);
    th=(D>=10&&D<=20)?'th':((dMod=D%10)==1)?'st':(dMod==2)?'nd':(dMod==3)?'rd':'th';
    formatString = formatString.replace("#YYYY#",YYYY).replace("#YY#",YY).replace("#MMMM#",MMMM).replace("#MMM#",MMM).replace("#MM#",MM).replace("#M#",M).replace("#DDDD#",DDDD).replace("#DDD#",DDD).replace("#DD#",DD).replace("#D#",D).replace("#th#",th);

    h=(hhh=dateObject.getHours());
    if (h==0) h=24;
    if (h>12) h-=12;
    hh = h<10?('0'+h):h;
    AMPM=(ampm=hhh<12?'am':'pm').toUpperCase();
    mm=(m=dateObject.getMinutes())<10?('0'+m):m;
    ss=(s=dateObject.getSeconds())<10?('0'+s):s;
    return formatString.replace("#hhh#",hhh).replace("#hh#",hh).replace("#h#",h).replace("#mm#",mm).replace("#m#",m).replace("#ss#",ss).replace("#s#",s).replace("#ampm#",ampm).replace("#AMPM#",AMPM);
}