function getCinemaEventListview(){
    var start = "<li><b>";
    var mid = "<p class='ui-li-aside'>";
    var end = "</p></b></li>";

    var eventID = localStorage.clicked_event_invitation;

    $('#cinema_invitation_info').append($("<ul data-role='listview' id='cinema_event_invitation_listview' data-inset='true' data-theme='d' class='ui-icon-alt'>"));
    getEventInformation(localStorage.clicked_event_invitation);
    var currentEvent = $.parseJSON(localStorage.currentEvent);

    $('#cinema_event_invitation_listview').empty();

    $('#cinema_event_invitation_listview').append("<li><h1>"+ currentEvent.name +"</h1></li>");
    $('#cinema_event_invitation_listview').append(start+"Dato"+mid+"Onsdag 22.05.2013"+end);
    $('#cinema_event_invitation_listview').append(start+ "Tid" + mid + getEventTime(new Date(parseInt(currentEvent.startDate)))+end);
    $('#cinema_event_invitation_listview').append(start+ "Sted" + "<p class='ui-li-aside' style='white-space: normal'>" + currentEvent.description+end);     
    $('#cinema_event_invitation_listview').append(start+ "Kostnad" + mid + getCost(currentEvent.cost)+end);
    $('#cinema_event_invitation_listview').append(start+ "Varighet" + mid + getDurationInHours(currentEvent.duration)+end);
    $('#cinema_event_invitation_listview').append(start+ "Antall deltakere" + mid + getNumberOfAttendees() +end);
    //$('#event_info_listview').append(start+"Venner "+mid+getAttendingFriends()+end);
    $('#cinema_event_invitation_listview').append("<li> Venner <br><p style='white-space: normal'><br>"+getAttendingFriends()+"</p></li>");
    $('#cinema_event_invitation_listview').append("<li>"+ "Kommentarer <br><p style='white-space: normal'><br>"+getComment(currentEvent.currency) +"</p></li>");
    if(currentEvent.maxparticipants < getNumberOfAttendees() && currentEvent.maxparticipants != -1){
        console.log("fullt");
         $('#cinema_event_invitation_listview').append("<li><img src='images/buttons-fullt.png' id='notattend'></li>");
    }else{
        console.log("ledig plass");
         $('#cinema_event_invitation_listview').append("<li><img src='images/button-attend.png' id='attend_cinema'></li>");
        
    }
    if($("#cinema_event_invitation_listview").hasClass('ui-listview')) $("#cinema_event_invitation_listview").listview("refresh");    
}

// Quiz invitation listview!
function getEventInvitationListview(){
    var start = "<li><b>";
    var mid = "<p class='ui-li-aside'>";
    var end = "</p></b></li>";

    var eventID = localStorage.clicked_event_invitation;
    //console.log("eventID: "+eventID);

    $('#invitation_info').append($("<ul data-role='listview' id='event_invitation_listview' data-inset='true' data-theme='d' class='ui-icon-alt'>"));
    getEventInformation(localStorage.clicked_event_invitation);
    var currentEvent = $.parseJSON(localStorage.currentEvent);
    //console.log(currentEvent);

    $('#event_invitation_listview').empty();
    
    var imgcss = "position: relative; top: 0; bottom: 0; left: 0; right: 0; margin:auto; width: 90px;";
    //var css = "margin: 0 auto;";
    var css = "text-align: center;";
    // var yes = "<img src='images/buttons-positive.png' style='"+imgcss+"' class='waffle_signup'/>";
    // var no = "<img src='images/buttons-negative.png' style='"+imgcss+"' class='waffle_signup'/>";

    var buttoncss = "width: 80px; position: relative; top: 10px;";

    var yes = "<img src='images/buttons-positive.png' style='"+buttoncss+"' id='waffle_signup_positive' class='waffle_signup'/>";
    var no = "<img src='images/buttons-negative.png' style='"+buttoncss+"' class='waffle_signup' id='waffle_signup_negative'/>";

    $('#event_invitation_listview').append("<li data-role='list-divider'>Treff nye venner!</li>");
    $('#event_invitation_listview').append("<li>"+"<h1><img src='images/handshake.png' id='invitation_image'/></h1></li>");
    $('#event_invitation_listview').append("<li style='"+css+"'>Tid: 22.05.2013 - 12:00<br>Sted: "+currentEvent.description+" </li>");
    $('#event_invitation_listview').append("<li style='"+css+"'> Dette arrangementet er i forkant av kinoforestillingen; Jag etter vind. Ønsker du å delta? </li>");
    $('#event_invitation_listview').append("<li><table id='table-yes'><tr><td>"+yes+"</td><td>"+no+"</td></tr></table></li>");



    if($("#event_invitation_listview").hasClass('ui-listview')) $("#event_invitation_listview").listview("refresh");

}

// Normal invitation listview
function getNormalEventInvitationListview(){
    var start = "<li><b>";
    var mid = "<p class='ui-li-aside'>";
    var end = "</p></b></li>";

    var eventID = localStorage.clicked_event_invitation;

    $('#normal_invitation_info').append($("<ul data-role='listview' id='normal_event_invitation_listview' data-inset='true' data-theme='d' class='ui-icon-alt'>"));
    getEventInformation(localStorage.clicked_event_invitation);
    var currentEvent = $.parseJSON(localStorage.currentEvent);

    $('#normal_event_invitation_listview').empty();

    $('#normal_event_invitation_listview').append("<li><h1>"+ currentEvent.name +"</h1></li>");
    $('#normal_event_invitation_listview').append(start+"Dato"+mid+getEventDate(new Date(parseInt(currentEvent.startDate)))+end);
    $('#normal_event_invitation_listview').append(start+ "Tid" + mid + getEventTime(new Date(parseInt(currentEvent.startDate)))+end);
    $('#normal_event_invitation_listview').append(start+ "Sted" + "<p class='ui-li-aside' style='white-space: normal'>" + currentEvent.description+end);     
    $('#normal_event_invitation_listview').append(start+ "Kostnad" + mid + getCost(currentEvent.cost)+end);
    $('#normal_event_invitation_listview').append(start+ "Varighet" + mid + getDurationInHours(currentEvent.duration)+end);
    $('#normal_event_invitation_listview').append(start+ "Antall deltakere" + mid + getNumberOfAttendees() +end);
    //$('#event_info_listview').append(start+"Venner "+mid+getAttendingFriends()+end);
    $('#normal_event_invitation_listview').append("<li> Venner <br><p style='white-space: normal'><br>"+getAttendingFriends()+"</p></li>");
    $('#normal_event_invitation_listview').append("<li>"+ "Kommentarer <br><p style='white-space: normal'><br>"+getComment(currentEvent.currency) +"</p></li>");
    if(currentEvent.maxparticipants < getNumberOfAttendees() && currentEvent.maxparticipants != -1){
        console.log("fullt");
         $('#normal_event_invitation_listview').append("<li><img src='images/buttons-fullt.png' id='notattend'></li>");
    }else{
        console.log("ledig plass");
         $('#normal_event_invitation_listview').append("<li><img src='images/button-attend.png' id='attendInvite'></li>");
        
    }
    if($("#normal_event_invitation_listview").hasClass('ui-listview')) $("#normal_event_invitation_listview").listview("refresh");
}

// Can take in events and ID of the div it should be appended to
function getActivityListview() {
	// Appending the listview to the div
	$('#one').append($("<ul data-role='listview' id='eventlistview' data-inset='true' data-theme='d' class='ui-icon-alt'></div>"));
    $('#eventlistview').empty();
	// Styling of each listview item
	//var start = "<li><a href='#'><b><h2>";
	//var mid = "<p class='ui-li-aside'>";
	var mid = "";
	//var end = "</p></b></li></ul>";
	var end = "</h2></b></a></li>";
	// Retrieving events from local storage
    var events = [];
    console.log(localStorage);
    //var events = localStorage.getItem('newEvents');
	if(localStorage.newEvents != null) events = $.parseJSON(localStorage.getItem('newEvents'));

	$.each(events, function(){
       // <li data-something="CommonLi"></li>
		// TODO DO NOT INCLUDE ALREADY ATTENDING EVENTS!
        //console.log(this.eventID);
        var start = "<li data-eventID="+this.eventID+"><a href='#event' data-transition='slide'><b><h2>";
		if(!alreadyRegistered(this)){
            //$('#eventlistview').append(start+mid+this.name+" <br> "+formatDate(new Date(parseInt(this.startDate)))+end);
            // HAXXX
            $('#eventlistview').append(start+mid+"<b style='white-space: normal'>"+this.name+"</b> <br><br> "+getEventDate(new Date(parseInt(this.startDate)))+end);
        }
	   //$('#eventlistview').append(start+mid+this.name+" <br> "+formatDate(new Date(parseInt(this.startDate)))+end).data(this);
    
    });
    // REFRESH LISTVIEW
    if($("#eventlistview").hasClass('ui-listview')) $("#eventlistview").listview("refresh");
    else{
        console.log("not refeshing");
    }
}

// Returns 
function alreadyRegistered(event){
    output = false;
    var registered = $.parseJSON(localStorage.registeredEvents);
    $.each(registered, function(){
        if(this.eventID == event.eventID) output = true;
    });
    return output;
}

// Can take in events and ID of the div it should be appended to
function getPastEventsListview() {
    // Appending the listview to the div
    $('#four').append($("<ul data-role='listview' id='pastEventsListview' data-inset='true' data-theme='d' class='ui-icon-alt'></div>"));
    $('#pastEventsListview').empty();
    // Styling of each listview item
    //var start = "<li><a href='#'><b><h2>";
    //var mid = "<p class='ui-li-aside'>";
    var mid = "";
    //var end = "</p></b></li></ul>";
    var end = "</h2></b></a></li>";
    // Retrieving events from local storage
    var events = $.parseJSON(localStorage.getItem('pastEvents'));

    $.each(events, function(){
       // <li data-something="CommonLi"></li>
        // TODO DO NOT INCLUDE ALREADY ATTENDING EVENTS!
        console.log(this.eventID);
        var start = "<li data-eventID="+this.eventID+"><a href='event-past.html'><b><h2>";
        // HAXXX
        //$('#pastEventsListview').append(start+mid+this.name+" <br> "+formatDate(new Date(parseInt(this.startDate)))+end);

        $('#pastEventsListview').append(start+mid+"<b style='white-space: normal'>"+this.name+"</b> <br><br> "+getEventDate(new Date(parseInt(this.startDate)))+end);
       //$('#eventlistview').append(start+mid+this.name+" <br> "+formatDate(new Date(parseInt(this.startDate)))+end).data(this);
    
    });
    // REFRESH LISTVIEW
    //if($("#eventlistview").hasClass('ui-listview')) $("#eventlistview").listview("refresh");
}

// Can take in events and ID of the div it should be appended to
function getRegisteredEventsListview() {
    // Appending the listview to the div
    $('#two').append($("<ul data-role='listview' id='registeredEventsListview' data-inset='true' data-theme='d' class='ui-icon-alt'></div>"));
    $('#registeredEventsListview').empty();
    // Styling of each listview item
    //var start = "<li><a href='#'><b><h2>";
    //var mid = "<p class='ui-li-aside'>";
    var mid = "";
    //var end = "</p></b></li></ul>";
    var end = "</h2></b></a></li>";
    // Retrieving events from local storage
    var events = $.parseJSON(localStorage.getItem('registeredEvents'));

    $.each(events, function(){
       // <li data-something="CommonLi"></li>
        // TODO DO NOT INCLUDE ALREADY ATTENDING EVENTS!
        //console.log(this.eventID);
        var start = "<li data-eventID="+this.eventID+"><a href='#event_attending'><b><h2>";

        $('#registeredEventsListview').append(start+mid+"<b style='white-space: normal'>"+this.name+"</b> <br><br> "+formatDate(new Date(parseInt(this.startDate)))+end);
       //$('#eventlistview').append(start+mid+this.name+" <br> "+formatDate(new Date(parseInt(this.startDate)))+end).data(this);
    
    });
    // REFRESH LISTVIEW
    if($("#registeredEventsListview").hasClass('ui-listview')) $("#registeredEventsListview").listview("refresh");
}

// Can take in events and ID of the div it should be appended to
function getEventTable() {
    var start = "<tr><td>";
    var mid = "</td><td>";
    var end = "</td></tr>";

    var eventID = localStorage.getItem('clicked_event');

    var currentEvent = "";
    $.each($.parseJSON(localStorage.getItem("newEvents")), function(key, value){
        if(value.eventID == eventID) currentEvent = this;
    });

    $('#event_info').append("<table id=event_table></table>");
    $('#event_info').append("<th colspan=2>"+ currentEvent.name +"<br>" + formatDate(new Date(parseInt(currentEvent.startDate)))+"</th>");
    $('#event_info').append(start+ "Sted" + mid + currentEvent.description+end);     
    $('#event_info').append(start+ "Kostnad" + mid + currentEvent.cost+end);
    $('#event_info').append(start+ "Varighet" + mid + currentEvent.duration+end);
    $('#event_info').append(start+ "Antall deltakere" + mid + currentEvent.numberattending+end);
    $('#event_info').append("<tr><td colspan=2>"+ "Kommentarer: <br>"+currentEvent.currency +end);
    //$('#event_info').append("<tr><td colspan=2>"+ currentEvent.currency +end);
    
    // $.each(currentEvent, function(key, value){
    //     if(key == "name") $('#event_info').append(start+ value +end);
    //     else $('#event_info').append(start+ key + mid + value +end);
    // });
}

function getFriendEventsListview(){

    // Mastertesting user
    // Prevents displaying events created by this user
    var filter_personID = "ff8080813e5a24c8013e64ff64fd0001";

    $('#three').append($("<ul data-role='listview' id='friendslistview' data-inset='true' data-theme='d' class='ui-icon-alt'></div>"));
    $('#friendslistview').empty();

    //var start = "<li data-eventID="+this.eventID+"><a href='event-friend.html'><b><h2>";
    var mid = "";
    var end = "</h2></b></a></li>";

    var friends = $.parseJSON(localStorage.getItem('friends'));

    $.each(friends, function(){
        if(this.personID != filter_personID){
            $('#friendslistview').append("<li data-role='list-divider'><b>"+this.firstname+" "+this.lastname+"</b></li>");
                if(this.events.length > 0){
                    $.each(this.events, function(){
                        //console.log(this);
                        if(this.personID != filter_personID){
                            var start = "<li data-eventID="+this.eventID+"><a href='#event_friend'><b><h2>";
                            $('#friendslistview').append(start+mid+"<b style='white-space: normal'>"+this.name+"</b> <br> <br> "+formatDate(new Date(parseInt(this.startDate)))+end);
                        }
                    });
                } else {
                    $('#friendslistview').append("<li><b>Ingen påmeldte aktiviteter.</b></li>");
                }
        }
        
        
    });

}

function getInvitationsListview(){

    $('#invitationList').append($("<ul data-role='listview' id='invitationlistview' data-inset='true' data-theme='d' class='ui-icon-alt'></div>"));
    $('#invitationlistview').empty();
    $('#invitationList').append($("<ul data-role='listview' id='friendrequestlistview' data-inset='true' data-theme='d' class='ui-icon-alt'></div>"));
    $('#friendrequestlistview').empty();

    //var start = "<li data-eventID="+this.eventID+"><a href='event-friend.html'><b><h2>";
    var date  = new Date().getTime();
    var mid = "";
    var end = "</h2></b></a></li>";

    var invitations = $.parseJSON(localStorage.getItem('invitations'));
    var friendrequests = $.parseJSON(localStorage.getItem('friend_requests')); 

    //Her skal event invtasjoner inn
    $('#invitationlistview').append("<li data-role='list-divider'><b>Invitasjoner til arrangementer</b></li>");
    $.each(invitations, function(){            
            var eID = this.eventID;
            getEventInformation(eID);
            console.log($.parseJSON(localStorage.currentEvent));
            var currentEvent = $.parseJSON(localStorage.currentEvent);

             console.log("KMR"+ currentEvent.startDate + ": "+date);
            if(currentEvent.startDate > date){
                console.log("KMR"+ currentEvent.startDate + ": "+date);
                // mastertesting personID
                 if(currentEvent.personID == "ff8080813e5a24c8013e64ff64fd0001"){
                    if(currentEvent.eventID == "166130"){
                        // CINEMA
                        var start = "<li data-eventID="+currentEvent.eventID+"><a href='#cinema-invitation-event'><b><h2>";
                    } else {
                        // WAFFLE
                        var start = "<li data-eventID="+currentEvent.eventID+"><a href='#quiz-invitation-event'><b><h2>";
                    }
                } else {
                    var start = "<li data-eventID="+currentEvent.eventID+"><a href='#invitation-event'><b><h2>";

                }
                $('#invitationlistview').append(start+mid+"<b style='white-space: normal'>"+currentEvent.name+"</b> <br><br><p> Fra: "+this.sender.firstname+" "+this.sender.lastname+"</p>"+end); 
            }
            
    });
    var li_size = $("#invitationlistview li").size();
    if(li_size === 1){
        $('#invitationlistview').append("<li> Ingen </li>");
    }


    //Her skal venneforespørrelser inn
    $('#friendrequestlistview').append("<li data-role='list-divider'><b>Venneforespørsler</b></li>");
    if(friendrequests.length > 0){
        $.each(friendrequests, function(){
        console.log(this.eventID);
            var start = "<li data-guestid="+this.sender.personID+" data-id="+this.eventID+" data-lastname="+this.sender.lastname+" data-firstname="+this.sender.firstname+"><a href='#invitation-friend'><b><h2>";
            $('#friendrequestlistview').append(start+mid+this.sender.firstname+" "+this.sender.lastname+end);
        });
    } else {
        $('#friendrequestlistview').append("<li>Ingen</li>");
    }


    if($('#invitationlistview').hasClass('ui-listview')){
        $("#invitationlistview").listview("refresh");
    } else {
        console.log("#invitationlistview not instantiated, and not refreshed!");
    }

    if($('#friendrequestlistview').hasClass('ui-listview')){
        $("#friendrequestlistview").listview("refresh");
    } else {
        console.log("#friendrequestlistview not instantiated, and not refreshed!");
    }
    
}

function getFriendInviteView(){
    console.log("KMR");
    var friendfirstname = localStorage.getItem('clicked_friend_first');
    var friendlastname = localStorage.getItem('clicked_friend_last');
    console.log(""+friendfirstname+" "+friendlastname);
    //$('#friend_invite').empty();
    //$('#friend_invite').append("<p><strong>"+ friendfirstname + " " +friendlastname+ " har sendt deg en venneforespørsel, ønsker du å godta?</strong></p>");
 //***********************************************************************************
    var start = "<li><b>";
    var mid = "<p class='ui-li-aside'>";
    var end = "</p></b></li>";

    //console.log("eventID: "+eventID);

    $('#invitation_friend_info').append($("<ul data-role='listview' id='event_invitation_friend_listview' data-inset='true' data-theme='d' class='ui-icon-alt'>"));
    //console.log(currentEvent);

    $('#event_invitation_friend_listview').empty();
    
    var imgcss = "position: relative; top: 0; bottom: 0; left: 0; right: 0; margin:auto; width: 90px;";
    //var css = "margin: 0 auto;";
    var css = "text-align: center;";
    // var yes = "<img src='images/buttons-positive.png' style='"+imgcss+"' class='waffle_signup'/>";
    // var no = "<img src='images/buttons-negative.png' style='"+imgcss+"' class='waffle_signup'/>";

    var buttoncss = "width: 80px; position: relative; top: 10px;";

    var yes = "<img src='images/buttons-positive.png' style='"+buttoncss+"' id='friend_positive' class='waffle_signup'/>";
    var no = "<img src='images/buttons-negative.png' style='"+buttoncss+"' id='friend_positive' class='waffle_signup'/>";

    $('#event_invitation_friend_listview').append("<li data-role='list-divider'>Ny venneforespørsel</li>");
    $('#event_invitation_friend_listview').append("<li>"+"<h1><img src='images/friend.png' id='friend_image'/></h1></li>");
    $('#event_invitation_friend_listview').append("<li style='"+css+"'>"+ friendfirstname + " " +friendlastname+ " har sendt deg en venneforespørsel. Ønsker du å godta?</li>");;
    $('#event_invitation_friend_listview').append("<li><table id='table-yes'><tr><td>"+yes+"</td><td>"+no+"</td></tr></table></li>");

    if($("#event_invitation_friend_listview").hasClass('ui-listview')){
        $("#event_invitation_friend_listview").listview("refresh");
    } 

}


function getFriendEventInfo(){
    $('#event-friend').append($("<ul data-role='listview' id='friend_event_info_listview' data-inset='true' data-theme='d' class='ui-icon-alt'>"));
    $('#friend_event_info_listview').empty();

    var start = "<li><b>";
    var mid = "<p class='ui-li-aside'>";
    var end = "</p></b></li>";

    var eventID = localStorage.clicked_friend_event;

    var currentEvent = "";
    
    console.log("Clicked friend event: "+eventID);

    $.each($.parseJSON(localStorage.friends), function(){
        //console.log("Finding event ...");

        $.each(this.events, function(){
            //console.log("Scanning event: "+this.eventID);
            if(this.eventID == eventID){
                currentEvent = this;
                //console.log("Event found.");
            } 
        });
    });
    
    $('#friend_event_info_listview').append("<li><h1>"+ currentEvent.name +"</h1></li>");
    $('#friend_event_info_listview').append(start+"Dato"+mid+getEventDate(new Date(parseInt(currentEvent.startDate)))+end);
    $('#friend_event_info_listview').append(start+ "Tid" + mid + getEventTime(new Date(parseInt(currentEvent.startDate)))+end);
    $('#friend_event_info_listview').append("<li style='height: 40px'><b>"+ "Sted" + "<p class='ui-li-aside' style='white-space: normal'>" + currentEvent.description+end);     
    $('#friend_event_info_listview').append(start+ "Kostnad" + mid + getCost(currentEvent.cost)+end);
    $('#friend_event_info_listview').append(start+ "Varighet" + mid + getDurationInHours(currentEvent.duration)+end);
    $('#friend_event_info_listview').append(start+ "Antall deltakere" + mid + getNumberOfAttendees() +end);
    //$('#friend_event_info_listview').append(start+"Venner "+mid+getAttendingFriends()+end);
    $('#friend_event_info_listview').append("<li> Venner <br><p style='white-space: normal'><br>"+getAttendingFriends()+"</p></li>");
    $('#friend_event_info_listview').append("<li>"+ "Kommentarer <br><p style='white-space: normal'><br>"+getComment(currentEvent.currency) +"</p></li>");
    if(currentEvent.maxparticipants < getNumberOfAttendees() && currentEvent.maxparticipants != -1){
        console.log("fullt");
         $('#friend_event_info_listview').append("<li><img src='images/buttons-fullt.png' id='notattend'></li>");
    }else{
        console.log("ledig plass");
         $('#friend_event_info_listview').append("<li><img src='images/button-attend.png' id='attend'></li>");
        
    }
    if($('#friend_event_info_listview').hasClass('ui-listview')){
        $("#friend_event_info_listview").listview("refresh");
    } else {
        console.log("#friend_event_info_listview not instantiated!");
    }
    
}


// Can take in events and ID of the div it should be appended to. Should not show "attend" button if already attending. Toggle between attend/resign imgbutton.
function getEventListview() {
    var start = "<li><b>";
    var mid = "<p class='ui-li-aside'>";
    var end = "</p></b></li>";

    var eventID = localStorage.getItem('clicked_event');


    $('#event_info').append($("<ul data-role='listview' id='event_info_listview' data-inset='true' data-theme='d' class='ui-icon-alt'>"));
    $('#event_info_listview').empty();
    getEventInformation(localStorage.clicked_event);
    var currentEvent = $.parseJSON(localStorage.currentEvent);
    console.log(currentEvent);
    
   
    $('#event_info_listview').append("<li><h1>"+ currentEvent.name +"</h1></li>");
    $('#event_info_listview').append(start+"Dato"+mid+getEventDate(new Date(parseInt(currentEvent.startDate)))+end);
    $('#event_info_listview').append(start+ "Tid" + mid + getEventTime(new Date(parseInt(currentEvent.startDate)))+end);
    $('#event_info_listview').append("<li style='height: 40px'><b>"+ "Sted" + "<p class='ui-li-aside' style='white-space: normal'>"+ currentEvent.description+end);     
    $('#event_info_listview').append(start+ "Kostnad" + mid + getCost(currentEvent.cost)+end);
    $('#event_info_listview').append(start+ "Varighet" + mid + getDurationInHours(currentEvent.duration)+end);
    $('#event_info_listview').append(start+ "Antall deltakere" + mid + getNumberOfAttendees() +end);
    //$('#event_info_listview').append(start+"Venner "+mid+getAttendingFriends()+end);
    $('#event_info_listview').append("<li> Venner <br><p style='white-space: normal'><br>"+getAttendingFriends()+"</p></li>");
    $('#event_info_listview').append("<li>"+ "Kommentarer <br><p style='white-space: normal'><br>"+getComment(currentEvent.currency) +"</p></li>");
     if(currentEvent.maxparticipants < getNumberOfAttendees() && currentEvent.maxparticipants != -1){
        console.log("fullt");
         $('#event_info_listview').append("<li><img src='images/buttons-fullt.png' id='notattend'></li>");
    }else{
        console.log("ledig plass");
         $('#event_info_listview').append("<li><img src='images/button-attend.png' id='attend'></li>");
        
    }


    if($('#event_info_listview').hasClass('ui-listview')){
        $("#event_info_listview").listview("refresh");
    } else {
        console.log("#event_info_listview not instantiated!");
    }
    

}

function getPastEventInformationListview() {
    var start = "<li><b>";
    var mid = "<p class='ui-li-aside'>";
    var end = "</p></b></li>";

    //var eventID = localStorage.getItem('clicked_event');


    $('#past_event_info').append($("<ul data-role='listview' id='past_event_info_listview' data-inset='true' data-theme='d' class='ui-icon-alt'>"));
    $('#past_event_info_listview').empty();
    getEventInformation(localStorage.clicked_past_event);
    var currentEvent = $.parseJSON(localStorage.currentEvent);
    console.log(currentEvent);
    
    $('#past_event_info_listview').append("<li><h1>"+ currentEvent.name +"</h1></li>");
    $('#past_event_info_listview').append(start+"Dato"+mid+getEventDate(new Date(parseInt(currentEvent.startDate)))+end);
    $('#past_event_info_listview').append(start+ "Tid" + mid + getEventTime(new Date(parseInt(currentEvent.startDate)))+end);
    $('#past_event_info_listview').append("<li style='height: 40px'><b>"+ "Sted" + "<p class='ui-li-aside' style='white-space: normal'>" + currentEvent.description+end);     
    $('#past_event_info_listview').append(start+ "Kostnad" + mid + getCost(currentEvent.cost)+end);
    $('#past_event_info_listview').append(start+ "Varighet" + mid + getDurationInHours(currentEvent.duration)+end);
    $('#past_event_info_listview').append(start+ "Antall deltakere" + mid + getNumberOfAttendees() +end);
    //$('#event_info_listview').append(start+"Venner "+mid+getAttendingFriends()+end);
    $('#past_event_info_listview').append("<li> Venner <br><p style='white-space: normal'><br>"+getAttendingFriends()+"</p></li>");
    $('#past_event_info_listview').append("<li>"+ "Kommentarer <br><p style='white-space: normal'><br>"+getComment(currentEvent.currency) +"</p></li>");

    if($('#past_event_info_listview').hasClass('ui-listview')){
        $("#past_event_info_listview").listview("refresh");
    } else {
        console.log("#past_event_info_listview not instantiated!");
    }
    

}

function getAttendingEventListview() {
    var start = "<li><b>";
    var mid = "<p class='ui-li-aside'>";
    var end = "</p></b></li>";
    var selectStart = "<li><label for='select-choice-0' class='select'>Inviter en venn:</label><fieldset class='ui-grid-a'><div class='ui-block-a'><select name='select-choice-0' id='select-choice-0' data-mini='true'>";
    var selectEnd = "</select></div><div class='ui-block-d'><button type='button' id='invitationbutton' onclick='sendEventInvitation()' data-theme='b' data-mini='true'>Send</button></div></fieldset></li>"
    var eventID = localStorage.clicked_attending_event;
    getEventInformation(eventID);

    $('#attending_event_info').append($("<ul data-role='listview' id='attending_event_listview' data-inset='true' data-theme='d' class='ui-icon-alt'>"));
    $('#attending_event_listview').empty();
    var currentEvent = $.parseJSON(localStorage.currentEvent);

    var friends = $.parseJSON(localStorage.getItem('friends')); 
    var friendstext;
    $.each(friends, function(){    
        console.log("personID: "+this.personID);
        console.log("Navn: "+this.firstname+" "+this.lastname);        
        // friendstext += "<option value="+this.personID+">"+this.personID+"</option>"
        friendstext += "<option value="+this.personID+">"+this.firstname+" "+this.lastname+"</option>"

    });
    console.log("friendstext:" +friendstext);


    $('#attending_event_listview').append("<li><h1>"+ currentEvent.name +"</h1></li>");
    $('#attending_event_listview').append(start+"Dato"+mid+getEventDate(new Date(parseInt(currentEvent.startDate)))+end);
    $('#attending_event_listview').append(start+ "Tid" + mid + getEventTime(new Date(parseInt(currentEvent.startDate)))+end);
    $('#attending_event_listview').append("<li style='height: 40px'><b>"+ "Sted" + "<p class='ui-li-aside' style='white-space: normal'>"+currentEvent.description+"</p>"+end);     
    $('#attending_event_listview').append(start+ "Kostnad" + mid + getCost(currentEvent.cost)+end);
    $('#attending_event_listview').append(start+ "Varighet" + mid + getDurationInHours(currentEvent.duration)+end);
    $('#attending_event_listview').append(start+ "Antall deltakere" + mid + getNumberOfAttendees() +end);
    //$('#attending_event_listview').append(start+"Venner "+mid+getAttendingFriends()+end);
    $('#attending_event_listview').append("<li> Venner <br><p style='white-space: normal'><br>"+getAttendingFriends()+"</p></li>");
    $('#attending_event_listview').append("<li>"+ "Kommentarer <br><p style='white-space: normal'><br>"+getComment(currentEvent.currency) +"</p></li>");
    //$('#attending_event_listview').append("<li><img src='images/buttons-invite.png' id='invite_button'></li>");
    if(currentEvent.eventID != "166130") $('#attending_event_listview').append(selectStart+friendstext+selectEnd);
    $('#attending_event_listview').append("<li><img src='images/button-cancel_signup.png' id='cancel_signup'></li>");

    // REFRESH SELECTOR AND SEND BUTTON TOO!
    // ID select-choice-0
    // ID invitationbutton
    //$('#select-choice-0').select();


    
    
    if($('#attending_event_listview').hasClass('ui-listview')){
        $("#attending_event_listview").listview("refresh");
    } else {
        console.log("#attending_event_listview not instantiated!");
    }
    refreshAtteidningEventElements();
}

function refreshAtteidningEventElements(){
    $('#invitationbutton').button();
    $('#select-choice-0').selectmenu();
    $('#select-choice-0').selectmenu('refresh', true);
}

function getComment(comment){
    if(comment == undefined) return "Ingen";
    else return comment;
}

function getCost(cost){
    if(cost == 0.0 || cost == undefined) return "Ingen";
    else return cost+" kr";
}

function getNumberOfAttendees(){
    if(localStorage.attendees != undefined){
        return $.parseJSON(localStorage.attendees).length;
    } else {
        return 0;
    }
    // if($.parseJSON(localStorage.attendees) != null && $.parseJSON(localStorage.attendees != undefined)) return $.parseJSON(localStorage.attendees).length;
    // else return 0;
}

function getDurationInHours(duration){
    console.log("DURATION:");
    console.log(duration);
    //if(duration == "undefined") return "LOL";
    if(duration == undefined) return "Uspesifisert";
    if(duration < 60) return duration+" min";
    else{
        var hours = Math.floor(duration / 60);          
        var minutes = duration % 60;
        if(minutes == 0){
            if(hours > 1) return hours+" timer";
            else return hours+" time";
        }
        if(hours < 2) return hours+" time "+minutes+" min";
        else return hours+" timer "+minutes+" min";
    } 
}

function getEventDate(date){
    if(date != undefined) return date.customFormat("#DDDD# #DD#.#MM#.#YYYY#");
        //date.customFormat("#DDDD# #DD#.#MM#.#YYYY#");
    else return "Uspesifisert";
}

function getEventTime(date){
    //return "ASSHOLE!";
    if(date == undefined){
        return "Uspesifisert";
    } else {
        return date.customFormat("#hhh#:#mm#");
    }
}

function formatDate(date){
	return date.customFormat("#DDDD# #DD#.#MM#.#YYYY# - #hhh#:#mm#");
}

// CAN BE MOVED TO ANOTHER *.JS FILE
Date.prototype.customFormat = function(formatString){
    var YYYY,YY,MMMM,MMM,MM,M,DDDD,DDD,DD,D,hhh,hh,h,mm,m,ss,s,ampm,AMPM,dMod,th;
    var dateObject = this;
    YY = ((YYYY=dateObject.getFullYear())+"").slice(-2);
    MM = (M=dateObject.getMonth()+1)<10?('0'+M):M;
    MMM = (MMMM=["Januar","Februar","Mars","April","Mai","Juni","Juli","August","September","Oktober","November","Desember"][M-1]).substring(0,3);
    DD = (D=dateObject.getDate())<10?('0'+D):D;
    DDD = (DDDD=["Søndag","Mandag","Tirsdag","Onsdag","Torsdag","Fredag","Lørdag"][dateObject.getDay()]).substring(0,3);
    th=(D>=10&&D<=20)?'th':((dMod=D%10)==1)?'st':(dMod==2)?'nd':(dMod==3)?'rd':'th';
    formatString = formatString.replace("#YYYY#",YYYY).replace("#YY#",YY).replace("#MMMM#",MMMM).replace("#MMM#",MMM).replace("#MM#",MM).replace("#M#",M).replace("#DDDD#",DDDD).replace("#DDD#",DDD).replace("#DD#",DD).replace("#D#",D).replace("#th#",th);

    h=(hhh=dateObject.getHours());
    if (h==0) h=24;
    if (h>12) h-=12;
    hh = h<10?('0'+h):h;
    AMPM=(ampm=hhh<12?'am':'pm').toUpperCase();
    mm=(m=dateObject.getMinutes())<10?('0'+m):m;
    ss=(s=dateObject.getSeconds())<10?('0'+s):s;
    return formatString.replace("#hhh#",hhh).replace("#hh#",hh).replace("#h#",h).replace("#mm#",mm).replace("#m#",m).replace("#ss#",ss).replace("#s#",s).replace("#ampm#",ampm).replace("#AMPM#",AMPM);
}

// Not sure if eventID is needed as input parameter. Getting it from localstorage instead.
function getAttendingFriends(){
    var output = "";
    if(localStorage.attendees != null && localStorage.friends != null){
            $.each($.parseJSON(localStorage.attendees), function(){
            var pID = this.personID;
            $.each($.parseJSON(localStorage.friends), function(){
                if(this.personID == pID) output += (this.firstname + " " +this.lastname +", ");
            });
        });
        if(output.charAt(output.length-2) == ",") output = output.substring(0, output.length-2);
    }
    if(output == "") output = "Ingen";
    return output;
}
